'+--------------------------------------------------------------------------+
'|                                                                          |
'|                               GDImage.dll                                |
'|            Graphic control DLL based on the GDIPLUS flat API             |
'|                                                                          |
'|                              Version 1.26                                |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                                                                          |
'|                           copyright (c) 2005                             |
'|                                                                          |
'|                Patrice Terrier http://www.zapsolution.com                |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 10-16-2005 (MM-DD-YYYY)            |
'|                        Last revised : 12-17-2005 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+
'
'****************************************************************************
' CONSTANTS
'
  $GDIPLUSIMG        = ".DIB.EMF.GIF.JPG.JPEG.PNG.TIF.TIFF.WMF."
  $GDIPLUSEXT        = $GDIPLUSIMG + "BMP.ICO."
'
  $zLim              = "|"
  $Anti              = "\"
  $Dot               = "."
  $GDImageClassName  = "ZIMAGECTRL"  ' Class name for GDImage standard control.
  $GLImageClassName  = "ZOPENGLCTRL" ' Class name for OpenGL control.
'
'****************************************************************************
' Version 1.00
' --------------------
' Load the GDImage.dll
' --------------------
' Must be done in the WinMain section BEFORE USING any of the GDImage function.
' Parameter: None
  DECLARE FUNCTION RegisterGDImageClass LIB "GDIMAGE.DLL" ALIAS "RegisterGDImageClass" () AS LONG
' Return:
' 0 = means failure, any other value means registered.
'****************************************************************************
'
'****************************************************************************
' Version 1.00
' Default function to create a GDImage control
' (Alias zCreateImageCtrl)
  DECLARE FUNCTION ZI_CreateWindow LIB "GDIMAGE.DLL" ALIAS "ZI_CreateWindow" ( _
  BYVAL hParent AS LONG, _  ' The Window/Dialog container
  BYVAL x AS LONG, _        ' The control top left corner horizontal location
  BYVAL y AS LONG, _        ' The control top left corner vertical location
  BYVAL xW AS LONG, _       ' The control width
  BYVAL yH AS LONG, _       ' The control height
  BYVAL ControlID AS LONG _ ' The control unique IDentifier
  ) AS LONG
' Return:
' The handle of the newly created control
'
' --------------------------------------
' Alternate methode using CreateWindowEx
' --------------------------------------
' Style&   = %WS_CHILD OR %WS_VISIBLE OR %WS_BORDER
' StyleEx& = 0
' CALL CreateWindowEx(StyleEx&, _
'                    "ZIMAGECTRL", _                 ' window class name
'                    "e:\pictures\image.png<fit>", _ ' Optional FullPathName to picture
'                     Style&, _                      ' window style
'                     10, _                          ' initial x position
'                     10, _                          ' initial y position
'                     150, _                         ' Calculate Window Width
'                     150, _                         ' Calculate Window Height
'                     hMain, _                       ' parent window handle
'                     %ID_THUMBCTRL, _               ' ControlID
'                     GetModuleHandle(""), _         ' program instance handle
'                     BYVAL 0)                       ' creation parameters
'
' ---------------------------------------
' Alternate methode using DDT CONTROL ADD
' ---------------------------------------
'  CONTROL ADD "ZIMAGECTRL", _
'              hDlg, _
'              %IDC_CUSTOMCONTROL, _
'              "e:\picture.jpg", _
'              10, 10, 640, 480, _
'              %WS_CHILD OR %WS_VISIBLE OR %WS_HSCROLL OR %WS_VSCROLL, _
'              %WS_EX_LEFT OR %WS_EX_LTRREADING OR %WS_EX_RIGHTSCROLLBAR
'
'****************************************************************************
'
'****************************************************************************
' Version 1.00
' Display the common file selector dialog using thumbnail preview for the supported graphic format.
' (Alias zImageLoadDialog)
  DECLARE FUNCTION ZI_LoadDialog LIB "GDIMAGE.DLL" ALIAS "ZI_LoadDialog" ( _
  BYVAL hGDImageCtrl AS LONG _ ' The GDimage control handle.
  ) AS STRING
' Return:
' The FullPathName of the selected picture
'****************************************************************************
'
'****************************************************************************
' Version 1.00
' Display the common save to file dialog providing a valid hGDImageCtrl handle
' (Alias zImageSaveDialog)
  DECLARE FUNCTION ZI_SaveDialog LIB "GDIMAGE.DLL" ALIAS "ZI_SaveDialog" ( _
  BYVAL hParent AS LONG, _             ' The parent window handle.
  BYVAL hGDImageCtrl AS LONG _         ' The GDImage control handle.
  ) AS LONG
' Return:
' Successfull ErrCode& = 0
' Error       ErrCode
'****************************************************************************
'
'****************************************************************************
' Version 1.00
' Save the content of a GDImage control to any of the supported graphic format
' Must be a supported graphic format, see $GDIPLUSEXT.
' (Alias zSaveImageToFile)
  DECLARE FUNCTION ZI_SaveToFile LIB "GDIMAGE.DLL" ALIAS "ZI_SaveToFile" ( _
  zFullPathName AS ASCIIZ, _           ' Full path name of the graphic file to save.
  BYVAL hGDImageCtrl AS LONG, _        ' The GDimage control handle.
  OPTIONAL BYVAL JpegQuality AS LONG _ ' Optional JPEG encoding quality 1-100:
  ) AS LONG                            ' Default 0 = QalityMax = 100
' Return:
' Successfull ErrCode& = 0
' Error       ErrCode
'****************************************************************************
'
'****************************************************************************
' Version 1.00
' Set the image file to use with the control.
' Must be a supported graphic format, see $GDIPLUSEXT.
' (Alias zSetImageFromFile)
  DECLARE SUB ZI_SetFromFile LIB "GDIMAGE.DLL" ALIAS "ZI_SetFromFile" ( _
  BYVAL hGDImageCtrl AS LONG, _  ' The GDimage control handle.
  zFullPathName AS ASCIIZ _      ' Full path name to the graphic file to display
  )
' This function is the same than using :
' CALL SendMessage (hCtrl, %WM_SETTEXT, 0, STRPTR(FullPathName$))
'****************************************************************************
'
'****************************************************************************
' Version 1.00
' Set property of a GDImage control
' (Alias zGetProperty)
  DECLARE FUNCTION ZI_GetProperty LIB "GDIMAGE.DLL" ALIAS "ZI_GetProperty" ( _
  BYVAL hGDImageCtrl AS LONG, _ ' The GDimage control handle.
  BYVAL Property AS LONG _      ' A %ZI_ predefined constant (see the list below)
  ) AS LONG
' Return:
' The matching property value
'
' Get property from a GDImage control
' (Alias zSetProperty)
  DECLARE SUB ZI_SetProperty LIB "GDIMAGE.DLL" ALIAS "ZI_SetProperty" ( _
  BYVAL hGDImageCtrl AS LONG, _ ' The control handle.
  BYVAL Property AS LONG, _     ' A %ZI_ predefined constant (see the list below)
  BYVAL Parameter AS LONG _     ' A parameter matching the type of property to set or retrieve.
  )
'
' See below the list of GDImage properties:
' Note: Constants prefixed with %ZI_ are for IMAGE control
  %ZI_DC             = 1  ' Internal DC
  %ZI_Bitmap         = 2  ' Memory Bitmap
  %ZI_Horizontal     = 3  ' Horizontal scrolling position
  %ZI_Vertical       = 4  ' Vertical scrolling position
  %ZI_GradientTop    = 5  ' Top gradiant color backgroud
  %ZI_GradientBottom = 6  ' Bottom gradiant color backgroud

  %ZI_FitToWindow    = 7  ' Resize the image to fit the view port
                          ' And use any of this constant as Parameter
                           %ZI_QualityDefault = -1
                           %ZI_QualityGood    = 1  ' Best performance
                           %ZI_QualityHigh    = 2  ' Best rendering quality
' DO NOT use or alter thsese properties!
  %ZI_PaintDC        = 8  ' Internal DC
  %ZI_PaintBitmap    = 9  ' Memory Bitmap
  %ZI_Reserved       = 10 ' Animated frame parameters : LOWRD = FrameWidth, HIWRD = FrameCount
'
  %Extend_cbWndExtra = %ZI_Reserved

  %ZI_GDIPLUSHANDLE  = 1  ' Load GDIPLUS Image handle
  
  %ZD_MAPCOLORFROM   = &h807F80   ' Maping color for 32-bit alphablending
  %ZI_MAPCOLORFROM   = &hFF807F80 ' Maping color for 32-bit alphablending
  %ZI_MAPCOLORTO     = &hFF808080 ' Maping color for 32-bit alphablending
  %ZI_MAPCOLORNULL   = &h00807F80 ' Maping color for 32-bit alphablending
  %ZI_MAPTRANSCOLOR  = &h807F80   ' Transparent maped color for 32-bit alphablending
'
'****************************************************************************
'
'****************************************************************************
' Version 1.00
' Paint the background of a GDImage control
' see property %ZI_GradientTop
' and property %ZI_GradientBottom
' (Alias zGradientPaintDC)
  DECLARE SUB ZI_GradientPaintDC LIB "GDIMAGE.DLL" ALIAS "ZI_GradientPaintDC" ( _
  BYVAL hDC AS LONG, _      ' A Windows DC (do not use ZI_GetDC except if you want to paint over the image)
  BYVAL x AS LONG, _        ' The top left corner horizontal location
  BYVAL y AS LONG, _        ' The top left corner vertical location
  BYVAL xW AS LONG, _       ' The width
  BYVAL yH AS LONG, _       ' The height
  BYVAL TopRGB AS LONG, _   ' The RGB color to use for the top
  BYVAL BottomRGB AS LONG _ ' The RGB color to use for the bottom
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.00
' Retrieve bitmap size from a supported GDI+ disk file (do not load the image)
' (Alias zGetImageSize)
  DECLARE SUB ZI_GetImageSizeFromFile LIB "GDIMAGE.DLL" ALIAS "ZI_GetImageSizeFromFile" ( _
  zFullPathName AS ASCIIZ, _      ' The name of the graphic file to detect size
  imgWidth AS LONG, _             ' Width of the picture
  imgHeight AS LONG _             ' Height of the picture
  )
' See: ZI_AdjustWindowRect to adjust the client size of a GDImage control.
'****************************************************************************
'
'****************************************************************************
' Version 1.00
' Get the private DC of GDImage control
  DECLARE FUNCTION ZI_GetDC LIB "GDIMAGE.DLL" ALIAS "ZI_GetDC" ( _
  BYVAL hGDImageCtrl AS LONG _ ' The GDimage control handle.
  ) AS LONG
' Return:
' The private DC of the GDImage control
' You can use this DC to draw on the GDImage memory bitmap using standard GDI command.
'
' DO NOT release this DC and AVOID to use DELETEDC on it!
'****************************************************************************
'
'****************************************************************************
' Version 1.04
' Get the GDImage.dll internal version number
' (Alias zGDImageVersion)
  DECLARE FUNCTION ZI_Version LIB "GDIMAGE.DLL" ALIAS "ZI_Version" () AS STRING
' Return:
' The version number of the form "#.#"
'****************************************************************************
'
'****************************************************************************
' Version 1.04
' Copy image to clipboard.
' (Alias zClipboardCopy)
  DECLARE FUNCTION ZI_ClipboardCopy LIB "GDIMAGE.DLL" ALIAS "ZI_ClipboardCopy" ( _
  BYVAL hGDImageCtrl AS LONG _ ' The GDimage control handle.
  ) AS LONG
' Return:
' TRUE (-1) if success, FALSE (0) if error

'****************************************************************************
'
'****************************************************************************
' Version 1.04
' Paste image from clipboard.
' (Alias zClipboardPaste)
  DECLARE FUNCTION ZI_ClipboardPaste LIB "GDIMAGE.DLL" ALIAS "ZI_ClipboardPaste" ( _
  BYVAL hGDImageCtrl AS LONG _ ' The GDimage control handle.
  ) AS LONG
' Return:
' TRUE (-1) if success, FALSE (0) if error
'****************************************************************************
'
'****************************************************************************
' Version 1.05
' Compute the client size for a specific GDImage control
' that will match exactly the picture size
  DECLARE SUB ZI_AdjustWindowRect LIB "GDIMAGE.DLL" ALIAS "ZI_AdjustWindowRect" ( _
  BYVAL StyleEx AS LONG, _ ' The CreateWindowEx Extended Style.
  imgW AS LONG, _          ' Width of the image.
  imgH AS LONG, _          ' Height of the image.
  BYVAL Style AS LONG _    ' The CreateWindowEx Style.
  )
' See: ZI_GetImageSizeFromFile to get an image size without loading it.
'****************************************************************************
'
'****************************************************************************
' Version 1.05
' Set the value for the alpha channel of GDImage layered window.
' Note: A layered window MUST use the POPUP style.
  DECLARE FUNCTION ZI_SetLayeredAlpha LIB "GDIMAGE.DLL" ALIAS "ZI_SetLayeredAlpha" ( _
  BYVAL hGDImageCtrl AS LONG, _ ' The GDimage control handle.
  BYVAL TransLevel AS BYTE _    ' The translucency level ranging from 0 to 255
  ) AS LONG
' Return:
' TRUE (-1) if success, FALSE (0) if error
'****************************************************************************
'
'****************************************************************************
' Version 1.06
' Create a window using a transparent color to build a region on the fly
' You can use this command with either a POPUP or CHILD window .
  DECLARE FUNCTION ZI_CreateWindowFromImage LIB "GDIMAGE.DLL" ALIAS "ZI_CreateWindowFromImage" ( _
  BYVAL Style AS LONG, _           ' The CreateWindowEx Style.
  zFullImagePath AS ASCIIZ, _      ' The name of an image file.
  BYVAL x AS LONG, _               ' The top left corner horizontal location
  BYVAL y AS LONG, _               ' The top left corner vertical location
  BYVAl hParent AS LONG, _         ' The main window parent handle
  BYVAL UseID AS LONG, _           ' Warning, DO NOT use an ID when using the %WS_POPUP style.
  BYVAL StyleEx AS LONG, _         ' The CreateWindowEx Extended Style.
  BYVAL UseTransColor AS LONG _    ' The transparent color that will be used to create the region.
  ) AS LONG
' Return:
' The new window handle or NULL if error.
'****************************************************************************
'
'****************************************************************************
' Version 1.07
' To retrieve the image size of specific GDimage control
  DECLARE SUB ZI_GetImageSizeFromControl LIB "GDIMAGE.DLL" ALIAS "ZI_GetImageSizeFromControl" ( _
  BYVAL hGDImageCtrl AS LONG, _ ' The GDimage control handle.
  imgW AS LONG, _               ' Width of the picture.
  imgH AS LONG _                ' Height of the picture.
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.07
' To force immediate refresh of a GDImage control display
  DECLARE SUB ZI_UpdateWindow LIB "GDIMAGE.DLL" ALIAS "ZI_UpdateWindow" ( _
  BYVAL hGDImageCtrl AS LONG, _ ' The GDimage control handle.
  BYVAL EraseFlag AS LONG _     ' Boolean flag to erase first the background.
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.11
' To anchor a GDImage control to a specific location when resizing parent window
' See: ANCHOR.GIF
  DECLARE FUNCTION ZI_SetAnchorMode LIB "GDIMAGE.DLL" ALIAS "ZI_SetAnchorMode" ( _
  BYVAL hGDImageCtrl AS LONG, _ ' The GDimage control handle.
  BYVAL AnchorMode AS LONG _    ' The anchor mode (see below)
  ) AS LONG
' Return:
' TRUE (-1) if success, FALSE (0) if error
'
' Version 1.12
' The function has been enhanced to anchor any type of control:
' button, static, edit, listbox, etc.
'
' ANCHOR Flags:
  %ANCHOR_NONE                = 0
  %ANCHOR_WIDTH               = 1
  %ANCHOR_RIGHT               = 2
  %ANCHOR_CENTER_HORZ         = 3
  %ANCHOR_HEIGHT              = 4
  %ANCHOR_HEIGHT_WIDTH        = 5
  %ANCHOR_HEIGHT_RIGHT        = 6
  %ANCHOR_BOTTOM              = 7
  %ANCHOR_BOTTOM_WIDTH        = 8
  %ANCHOR_BOTTOM_RIGHT        = 9
  %ANCHOR_CENTER_HORZ_BOTTOM  = 10
  %ANCHOR_CENTER_VERT         = 11
  %ANCHOR_CENTER_VERT_RIGHT   = 12
  %ANCHOR_CENTER              = 13
'****************************************************************************
'
'****************************************************************************
' Version 1.15
' Convert COLOR to 256 shade of GRAY
  DECLARE FUNCTION ZI_ConvertToGray LIB "GDIMAGE.DLL" ALIAS "ZI_ConvertToGray" ( _
  BYVAL hGDImageDC AS LONG _  ' A GDImage DC (ZI_GetDC) or any DC using an associated memory bitmap
  ) AS LONG
' Return:
' TRUE (-1) if success, FALSE (0) if error
'****************************************************************************
'
'****************************************************************************
' Version 1.15
' Replace a RGB color with another RGB color
  DECLARE SUB ZI_ReplaceRGBColor LIB "GDIMAGE.DLL" ALIAS "ZI_ReplaceRGBColor" ( _
  BYVAL hGDImageDC AS LONG, _  ' A GDImage DC (ZI_GetDC) or any DC using an associated memory bitmap
  BYVAL WasRGBColor&, _        ' The RGB color to replace
  BYVAL NewRGBColor& _         ' The new RGB color to use
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.15
' Compute the number of unique color(s) of an image shown in a GDImage control.
  DECLARE FUNCTION ZI_ColorCount LIB "GDIMAGE.DLL" ALIAS "ZI_ColorCount"( _
  BYVAL hGDImageCtrl AS LONG _ ' The GDImage control handle
  ) AS LONG
' Return:
' The number of unique color(s) being used in the image.
' Note: Overlay objects are not considered in the computation.
'****************************************************************************
'
'****************************************************************************
' Version 1.15
' Print image only, self centered on the paper sheet.
' Print will fit the paper size
  DECLARE FUNCTION ZI_PrintImage LIB "GDIMAGE.DLL" ALIAS "ZI_PrintImage" ( _
  BYVAL hGDImageCtrl AS LONG _ ' The GDImage control handle
  ) AS LONG
' Return:
' TRUE (-1) if success, FALSE (0) if error
'****************************************************************************
'
'****************************************************************************
' Version 1.15
' Print image + annotation, self centered on the paper sheet.
' Print will fit the paper size
  DECLARE FUNCTION ZI_PrintFull LIB "GDIMAGE.DLL" ALIAS "ZI_PrintFull" ( _
  BYVAL hGDImageCtrl AS LONG _
  ) AS LONG
' Return:
' TRUE (-1) if success, FALSE (0) if error
'****************************************************************************
'
'****************************************************************************
' Version 1.15
' Read image from a provided text buffer (STREAMING)
  DECLARE FUNCTION ZI_LoadImageFromStream LIB "GDIMAGE.DLL" ALIAS "ZI_LoadImageFromStream" ( _
  BYVAL hGDImageCtrl AS LONG, _        ' The GDImage control handle.
  BYVAL pBufferData AS BYTE PTR, _     ' Pointer to buffer holding data.
  BYVAL BufferSize AS LONG _           ' Size of the buffer. 
  ) AS LONG
' Return:
' TRUE (-1) if success, FALSE (0) if error
'****************************************************************************
'
'****************************************************************************
' Version 1.17
' To load any of the supported graphic format as a program resource
' directly to a GDImage control as background.
  DECLARE FUNCTION ZI_LoadFromResource LIB "GDIMAGE.DLL" ALIAS "ZI_LoadFromResource" ( _
  BYVAL hGDImageCtrl AS LONG, _        ' The GDImage control handle.
  zResourceName AS ASCIIZ _            ' The resource name identifier.
  ) AS LONG
' Return:
' IF the GDImage control handle is omited the returned parameter is a Bitmap handle.
'****************************************************************************
'
'****************************************************************************
' Version 1.17
' To GET the Width and Height of a STANDARD BITMAP
  DECLARE SUB ZI_GetBitmapSize LIB "GDIMAGE.DLL" ALIAS "ZI_GetBitmapSize" ( _
  BYVAL hBitmap AS LONG, _   ' Handle to a standard bitmap.
  BitmapWidth AS LONG, _     ' The width of the bitmap.
  BitmapHeight AS LONG _     ' The Height of the bitmap.
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.17
' Create a valid GDI BITMAP handle from FILE using any of the supported GDImage format.
  DECLARE FUNCTION ZI_CreateBitmapFromFile LIB "GDIMAGE.DLL" ALIAS "ZI_CreateBitmapFromFile" ( _
  zFullImagePath AS ASCIIZ, _      ' The name of an image file.
  BitmapWidth AS LONG, _           ' The width of the bitmap.
  BitmapHeight AS LONG _           ' The Height of the bitmap.
  ) AS LONG
' Return:
' A valid GDI bitmap handle (do not confuse GDI bitmap handle and GDI+ Image handle).
' Important:
' You must use DeleteObject(GDIBitmapHandle) when you do not need it anymore.
'****************************************************************************
'
'****************************************************************************
' Version 1.17
' To load the specified bitmap resource from the module's executable file. 
' The resource can use any of the supported GDImage graphic format.
' (See RESOURCE.RC example)
  DECLARE FUNCTION ZI_LoadBitmap LIB "GDIMAGE.DLL" ALIAS "ZI_LoadBitmap" ( _
  zResourceName AS ASCIIZ _            ' The resource name identifier.
  ) AS LONG
' Return:
' A valid GDI bitmap handle (do not confuse GDI bitmap handle and GDI+ Image handle).
' Important:
' You must use DeleteObject(GDIBitmapHandle) when you do not need it anymore.
'****************************************************************************
'
'****************************************************************************
' Version 1.17
' Create a valid GDIPLUS Image handle from FILE using any of the supported GDImage format.
  DECLARE FUNCTION ZI_CreateImageFromFile LIB "GDIMAGE.DLL" ALIAS "ZI_CreateImageFromFile" ( _
  zFullPathName AS ASCIIZ, _           ' Full path name to the graphic file to load.
  imageWidth AS LONG, _                ' The image width.
  imageHeight AS LONG, _               ' The image height.
  BYVAL RemoveARGBColor AS LONG, _     ' Boolean flag use %TRUE to remove ARGBColorToRemove.
  BYVAL ARGBColorToRemove AS LONG _    ' The ARGB color to remove.
  ) AS LONG
' Return:
' A valid GDIPLUS Image handle (do not confuse with a GDI Bitmap handle),
' or NULL if error.
'****************************************************************************
'
'****************************************************************************
' Version 1.17
' Create an empty image background (Bitmap) into a GDImage control.
' Use it to perform direct drawing, everything lying out of it (overlay objects) would be clipped.
  DECLARE FUNCTION ZI_CreateImageBackground LIB "GDIMAGE.DLL" ALIAS "ZI_CreateImageBackground" ( _
  BYVAL hGDImageCtrl AS LONG, _        ' The GDImage control handle.
  BYVAL BitmapWidth AS LONG, _         ' The width of the bitmap.
  BYVAL BitmapHeight AS LONG _         ' The Height of the bitmap.
  ) AS LONG
' Return:
' A valid GDImage DC (ZI_GetDC) you can use to draw in.
' Note: After drawing into the provided DC, use ZI_UpdateWindow to refresh the display.
'****************************************************************************
'
'****************************************************************************
' Version 1.17
' Remove a GDIPLUS Image object from memory.
  DECLARE SUB ZI_DeleteImageObject LIB "GDIMAGE.DLL" ALIAS "ZI_DeleteImageObject" ( _
  hImage AS LONG _                     ' A valid GDIPLUS Image handle
  )
' Comment:
' Use it as you would do with DeleteObject for a standard BITAMP handle.
'****************************************************************************
'
'****************************************************************************
' Version 1.17
' Perform image rotation in the specified DC, using a GDIPLUS Image handle.
  DECLARE SUB ZI_RotateImage LIB "GDIMAGE.DLL" ALIAS "ZI_RotateImage" ( _
  BYVAL hDC AS LONG, _                 ' A valid Device Context
  BYVAL hImage AS LONG, _              ' A valid GDIPLUS Image handle
  BYVAL x AS LONG, _                   ' The X coordinate
  BYVAL y AS LONG, _                   ' The Y coordinate
  BYVAL AngleDegree AS LONG, _         ' The rotation angle in degree to use
  BYVAL UseAlpha AS LONG _             ' The Alpha channel value (use 255 for standard opaque mode)
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.17
' Render GDIPLUS Image rotation into a specific GDImage control.
  DECLARE SUB ZI_RenderImageRotationToWindow LIB "GDIMAGE.DLL" ALIAS "ZI_RenderImageRotationToWindow" ( _
  BYVAL hGDImageCtrl AS LONG, _        ' The GDImage control handle.
  BYVAL hImage AS LONG, _              ' A valid GDIPLUS Image handle.
  BYVAL x AS LONG, _                   ' The X coordinate.
  BYVAL y AS LONG, _                   ' The Y coordinate.
  BYVAL AngleDegree AS LONG, _         ' The rotation angle in degree to use.
  BYVAL UseAlpha AS LONG _             ' The Alpha channel value (use 255 for standard opaque mode).
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.18
' Use a Bitmap to paint a tiled background in a specific GDImage control.
' Bitmap can provide from file or resource using any of the GDImage supported graphic format.
  DECLARE FUNCTION ZI_SetTiledBackground LIB "GDIMAGE.DLL" ALIAS "ZI_SetTiledBackground" ( _
  BYVAL hGDImageCtrl AS LONG, _        ' The GDImage control handle.
  BYVAL UseBitmap AS LONG _
  ) AS LONG
' Return:
' TRUE (-1) if success, FALSE (0) if error.
'****************************************************************************
'
'****************************************************************************
' Version 1.18
' Retrieve the Bitmap handle being used to tile a background in a specific GDImage control.
  DECLARE FUNCTION ZI_GetTiledBackground LIB "GDIMAGE.DLL" ALIAS "ZI_GetTiledBackground" ( _
  BYVAL hGDImageCtrl AS LONG _         ' The GDImage control handle.
  ) AS LONG
' Return:
' The background Bitmap handle, or NULL if there is no tiled background.
'****************************************************************************
'
'****************************************************************************
' Version 1.19
' Retrieve a copy of the entire bitmap for the selected GDImageDC,
' using a 2 dimensions array of the form (x,y) pointing directly to pixel.
' You can use the array coordinates as you would do with a standard DC, 
' because pixel 0,0 is at coordinate Array(0,0). 
' Once your are done with the array, the bitmap is replaced using ZI_SetDIBits.
' (see ZI_SetDIBits)
  DECLARE FUNCTION ZI_GetDIBits LIB "GDIMAGE.DLL" ALIAS "ZI_GetDIBits" ( _
  BYVAL hGDImageDC AS LONG, _              ' Any memory bitmap Device Context (like ZI_GetDC).
  PixelArray() AS LONG _                   ' Array using 2 dimensions (Y,Y) matching the pixel coordinates.
  ) AS LONG
' Return:
' Null if error, else success.
' Comment:
' Each pixel use ARGB color of the form Alpha, Red, Blue, Green (reading from left to right).
'****************************************************************************
'
'****************************************************************************
' Version 1.19
' Replace a copy of a bitmap that was retrieved as a device-independent bitmap.
' (see ZI_GetDIBits)
  DECLARE FUNCTION ZI_SetDIBits LIB "GDIMAGE.DLL" ALIAS "ZI_SetDIBits" ( _
  BYVAL hGDImageDC AS LONG, _              ' Any memory bitmap Device Context (like ZI_GetDC).
  PixelArray() AS LONG, _                  ' Array using 2 dimensions (Y,Y) matching the pixel coordinates.
  OPTIONAL BYVAL DoNotClearArray AS LONG _ ' Boolean flag, %TRUE = DO NOT clear the array
  )AS LONG
' Return:
' Null if error, else success.
'****************************************************************************
'
'****************************************************************************
' Version 1.22
' Delete the memory bitmap and device context associated to a GDImage control.
  DECLARE FUNCTION ZI_DeleteControlBitmap LIB "GDIMAGE.DLL" ALIAS "ZI_DeleteControlBitmap" ( _
  BYVAL hGDImageCtrl AS LONG _        ' The GDImage control handle.
  ) AS LONG
' Return:
' TRUE (-1) if success, FALSE (0) if error
'****************************************************************************
'
'****************************************************************************
' Load a graphic file and Resize it on the fly to create a Bitmap matching a specific size.
' Version 1.26
  DECLARE FUNCTION ZI_FitImageFromFile LIB "GDIMAGE.DLL" ALIAS "ZI_FitImageFromFile" ( _
  zFullPathName AS ASCIIZ, _      ' The name of the graphic file.
  BYVAL BoundWidth AS LONG, _     ' The bounding width.
  BYVAL BoundHeight AS LONG _     ' The bounding height.
  ) AS LONG
' Note:
' The image will be stretched to match the bounding size, however keeping the original aspect ratio
' between width and height.
' Return:
' A valid GDI bitmap handle (do not confuse GDI bitmap handle and GDI+ Image handle).
'****************************************************************************
'
'****************************************************************************
'****************************************************************************
'***                                                                      ***
'***                           DRAWING FUNCTIONS                          ***
'***                                                                      ***
'****************************************************************************
'****************************************************************************
'
' CONSTANTS prefixed with %ZD_ apply to DRAWING functions
  %ZD_TRANSCOLOR = &HFF00FF   ' Magenta color that is the default GDImage transparent color
  %ZD_TOPLEFTCOLOR = -1       ' Pixel color at location 0,0
'
' ZD_DrawText constants
' Version 1.09
  %ZD_TextHorzUp = &H0        ' Horizontal text orientation
  %ZD_TextVertUp = &H1        ' Vertical text orientation from bottom to top
  %ZD_TextVertDn = &H2        ' Vertical text orientation from top to bottom
  %ZD_HIDE       = &H0        ' FALSE
  %ZD_SHOW       = &H1        ' TRUE

' GDImage overlay Generic STYLE must be a 2^
  %ZS_HIDDEN     = %ZD_HIDE
  %ZS_VISIBLE    = %ZD_SHOW   ' VISIBLE, same as %WS_VISIBLE
  %ZS_SCROLL     = &H2        ' MOVE with scroll bars, default is FIX (do not scroll)
  %ZS_DRAFT      = &H4        ' Draft drawing mode

' GDImage Drawing STYLE         For all ZD_Drawxxx functions
  %ZD_DRAW_OUTLINE  = 1
  %ZD_DRAW_FILLED   = 2
  %ZD_DRAW_3DIN     = 3
  %ZD_DRAW_3DOUT    = 4
  %ZD_DRAW_OPEN     = 5
'
  %ZD_DRAW_REDRAW   = -1      ' Forces immediat redraw of parent object
  %ZD_DRAW_DEFERRED = 0       ' Defers redraw of parent object
'
'****************************************************************************
' Version 1.00
' Fills a rectangle using a specific RGB color.
  DECLARE SUB ZD_FillRect LIB "GDIMAGE.DLL" ALIAS "ZD_FillRect" ( _
  BYVAL hGDImageDC AS LONG, _ ' The GDImage DC (ZI_GetDC)
  BYVAL x AS LONG, _          ' The top left horizontal coordinate of the rectangle
  BYVAL y AS LONG, _          ' The top left vertical coordinate of the rectangle
  BYVAL xW AS LONG, _         ' The rectangle width
  BYVAL yH AS LONG, _         ' The rectangle height
  BYVAL RGBcolor AS LONG _    ' The RGB color to use
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.09
' Draw a text using a True Type Font, ARGB color, optional 3D effect and orientation
  DECLARE FUNCTION ZD_DrawTextToDC LIB "GDIMAGE.DLL" ALIAS "ZD_DrawTextToDC" ( _
  BYVAL hGDImageDC AS LONG, _          ' The GDImage DC (ZI_GetDC)
  zUseText AS ASCIIZ, _                ' The text to display
  BYVAL x AS LONG, _                   ' The X seed coordinate
  BYVAL y AS LONG, _                   ' The Y seed coordinate
  BYVAL ColrARGB AS LONG, _            ' The ARGB color to use
  zUseFont AS ASCIIZ, _                ' The "Tue Type Font" name to use
  BYVAL UseSize AS LONG, _             ' The size of the font in pixel
  OPTIONAL BYVAL UseShadow AS LONG, _  ' The shadow 3D offset
  OPTIONAL BYVAL Orientation AS LONG _ ' The text orientation (%ZD_TextHorzUp, %ZD_TextVertUp, %ZD_TextVertDn)
  ) AS LONG
' Return:
' TRUE (-1) if success, FALSE (0) if error.
'****************************************************************************
'
'****************************************************************************
' Version 1.09
' Compute an ARGB color to ensure compatibility with GDI+
  DECLARE FUNCTION ZD_ColorARGB LIB "GDIMAGE.DLL" ALIAS "ZD_ColorARGB"( _
  BYVAL AlphaChannel AS BYTE, _ ' The translucency level ranging from 0 to 255.
  BYVAL ColrRGB??? _            ' The classical RGB() color to use.
  ) AS LONG
' Return:
' A 32-bit ARGB color.
'****************************************************************************
'
'****************************************************************************
' Version 1.09
' To retrieve the bounding size in pixel of specifc text using a True Type Font
' of a specific size.
  DECLARE FUNCTION ZD_GetTextBound LIB "GDIMAGE.DLL" ALIAS "ZD_GetTextBound" ( _
  zUseText AS ASCIIZ, _                ' The text to display.
  zUseFont AS ASCIIZ, _                ' The "Tue Type Font" name to use.
  BYVAL UseSize AS LONG, _             ' The size of the font in pixel.
  BYREF BoundingWidth AS LONG, _       ' The bounding width.
  BYREF BoundingHeight AS LONG, _      ' The bounding height.
  OPTIONAL BYVAL Orientation AS LONG _ ' The text orientation (%ZD_TextHorzUp, %ZD_TextVertUp, %ZD_TextVertDn).
  ) AS LONG
' Return:
' The width and height of the bounding rectangle that matches the text being used.
'****************************************************************************
'
'****************************************************************************
' Version 1.09
' Create a TEXT overlay object.
' Each overlay object must have a unique identifier.
' TEXT overlay is independant of the image background that is not altered.
  DECLARE FUNCTION ZD_DrawTextToCtrl LIB "GDIMAGE.DLL" ALIAS "ZD_DrawTextToCtrl" ( _
  BYVAL hGDImageCtrl AS LONG, _        ' The GDImage control handle.
  zUseText AS ASCIIZ, _                ' The text to display.
  BYVAL x AS LONG, _                   ' Top left X coordinate.
  BYVAL y AS LONG, _                   ' Top left Y coordinate.
  BYVAL ColrARGB AS LONG, _            ' The ARGB color to use.
  zUseFont AS ASCIIZ, _                ' The "Tue Type Font" name to use.
  BYVAL UseSize AS LONG, _             ' The size of the font in pixel.
  BYVAL ObjID AS LONG, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  BYVAL ZS_STYLE AS LONG, _            ' The object Generic STYLE (use at least %ZS_VISIBLE to show it).
  OPTIONAL BYVAL UseShadow AS LONG, _  ' The shadow 3D offset.
  OPTIONAL BYVAL Orientation AS LONG _ ' The text orientation (%ZD_TextHorzUp, %ZD_TextVertUp, %ZD_TextVertDn).
  ) AS LONG
' Return:
' TRUE (-1) if success, FALSE (0) if error.
'****************************************************************************
'
'****************************************************************************
' Version 1.16
' To change on the fly the text of a TEXT overlay. 
  DECLARE SUB ZD_SetObjectText LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectText" ( _
  BYVAL ObjID AS LONG, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one)
  zUseText AS ASCIIZ _                 ' The text to display
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.10
' Create a RECTANGLE overlay object.
' Each overlay object must have a unique identifier.
' RECTANGLE overlay is independant of the image background that is not altered.
  DECLARE FUNCTION ZD_DrawRectangleToCtrl LIB "GDIMAGE.DLL" ALIAS "ZD_DrawRectangleToCtrl" ( _
  BYVAL hGDImageCtrl AS LONG, _        ' The GDImage control handle.
  BYVAL x AS LONG, _                   ' Top left X coordinate.
  BYVAL y AS LONG, _                   ' Top left Y coordinate.
  BYVAL xWidth AS LONG, _              ' Rectangle width.
  BYVAL yHeight AS LONG, _             ' Rectangle height.
  BYVAL ColrARGB AS LONG, _            ' The ARGB color to use.
  BYVAL BorderSize AS LONG, _          ' Size of the border (can be NULL).
  BYVAL ObjID AS LONG, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  BYVAL ZS_STYLE AS LONG, _            ' The object Generic STYLE (use at least %ZS_VISIBLE to show it).
  BYVAL ZD_STYLE AS LONG, _            ' The object Drawing STYLE (see below).
  OPTIONAL BYVAL Use3D AS LONG _       ' The shadow 3D offset.
  ) AS LONG
' GDImage Drawing STYLE                  Drawing mode:
' ---------------------                  -------------
' %ZD_DRAW_OUTLINE                       Border only (frame mode)
' %ZD_DRAW_FILLED                        Fill mode
' %ZD_DRAW_3DIN                          Fill with 3D-IN effect
' %ZD_DRAW_3DOUT                         Fill with 3D_Out effect
'
' Return:
' TRUE (-1) if visible, FALSE (0) if not
'****************************************************************************
'
'****************************************************************************
' Create ARROW overlay object.
' Version 1.14
' Each overlay object must have a unique identifier.
  DECLARE FUNCTION ZD_DrawArrowToCtrl LIB "GDIMAGE.DLL" ALIAS "ZD_DrawArrowToCtrl" ( _
  BYVAL hGDImageCtrl AS LONG, _        ' The GDImage control handle.
  BYVAL SeedX AS LONG, _               ' Swap SeedX and TargetX to select arrow orientation.
  BYVAL SeedY AS LONG, _               ' Swap SeedY and TargetY to select arrow orientation.
  BYVAL TargetX AS LONG, _             ' Swap TargetX and SeedX to select arrow orientation.
  BYVAL TargetY AS LONG, _             ' Swap TargetY and SeedY to select arrow orientation.
  BYVAL ColrARGB AS LONG, _            ' The ARGB color to use.
  BYVAL ArrowSize AS LONG, _           ' Size of the Arrow.
  BYVAL ObjID AS LONG, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  BYVAL ZS_STYLE AS LONG, _            ' The object Generic STYLE (use at least %ZS_VISIBLE to show it).
  BYVAL ZD_STYLE AS LONG, _            ' The Drawing mode.
  OPTIONAL BYVAL Use3D AS LONG _       ' The shadow 3D offset.
  ) AS LONG
' To change the arrow orientation, swap Seed and Target coordinates
' GDImage Drawing STYLE                  Drawing mode:
' ---------------------                  -------------
' %ZD_DRAW_FILLED                        Fill mode ONLY
'
' Return:
' TRUE (-1) if success, FALSE (0) if error
'****************************************************************************
'
'****************************************************************************
' Create ELLIPSE overlay object.
' Version 1.14
' Each overlay object must have a unique identifier.
  DECLARE FUNCTION ZD_DrawEllipseToCtrl LIB "GDIMAGE.DLL" ALIAS "ZD_DrawEllipseToCtrl" ( _
  BYVAL hGDImageCtrl AS LONG, _        ' The GDImage control handle.
  BYVAL TopLeftX AS LONG, _            ' The top X of the rectangular region matching the ellipse size.
  BYVAL TopLeftY AS LONG, _            ' The top Y of the rectangular region matching the ellipse size.
  BYVAL BottomRightX AS LONG, _        ' The bottom X of the rectangular region matching the ellipse size.
  BYVAL BottomRightY AS LONG, _        ' The bottom Y of the rectangular region matching the ellipse size.
  BYVAL ColrARGB AS LONG, _            ' The ARGB color to use.
  BYVAL OutlineSize AS LONG, _         ' Size of the outline.
  BYVAL ObjID AS LONG, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  BYVAL ZS_STYLE AS LONG, _            ' The object Generic STYLE (use at least %ZS_VISIBLE to show it).
  BYVAL ZD_STYLE AS LONG, _            ' The object Drawing STYLE (see below).
  OPTIONAL BYVAL Use3D AS LONG _       ' The shadow 3D offset.
  ) AS LONG
' The ellipse coordinates must match a rectangualr perimeter
' GDImage Drawing STYLE                  Drawing mode:
' ---------------------                  -------------
' %ZD_DRAW_OUTLINE                       Border only (frame mode)
' %ZD_DRAW_FILLED                        Fill mode
' %ZD_DRAW_3DIN                          Fill with 3D-IN effect
' %ZD_DRAW_3DOUT                         Fill with 3D_Out effect
'
' Return:
' TRUE (-1) if success, FALSE (0) if error.
'****************************************************************************
'
'****************************************************************************
' Version 1.14
' Create CURVE overlay object.
' Version 1.14
' Each overlay object must have a unique identifier.
  DECLARE FUNCTION ZD_DrawCurveToCtrl LIB "GDIMAGE.DLL" ALIAS "ZD_DrawCurveToCtrl" ( _
  BYVAL hGDImageCtrl AS LONG, _        ' The GDImage control handle.
  BYVAL pXY AS POINTS PTR, _           ' Pointer to an ARRAY of POINTS (holding x,y coordinates of each point).
  BYVAL ArraySize AS LONG, _           ' UBOUND - LBOUND + 1 = number of point in the array.
  BYVAL ColrARGB AS LONG, _            ' The ARGB color to use.
  BYVAL CurveSize AS LONG, _           ' Size of the curve.
  BYVAL ObjID AS LONG, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  BYVAL ZS_STYLE AS LONG, _            ' The object Generic STYLE (use at least %ZS_VISIBLE to show it).
  BYVAL ZD_STYLE AS LONG, _            ' The object Drawing STYLE (see below).
  OPTIONAL BYVAL Use3D AS LONG _       ' The shadow 3D offset.
  ) AS LONG
' Return:
' TRUE (-1) if success, FALSE (0) if error.
'
' GDImage Drawing STYLE                  Drawing mode:
' ---------------------                  -------------
' %ZD_DRAW_OUTLINE                       Border only (frame mode)
' %ZD_DRAW_FILLED                        Fill mode
' %ZD_DRAW_3DIN                          Fill with 3D-IN effect
' %ZD_DRAW_3DOUT                         Fill with 3D_Out effect
' %ZD_DRAW_OPEN                          Do not apply to rectangle
'****************************************************************************
'
'****************************************************************************
' Version 1.14
' Create POLYLINE overlay object.
' Version 1.14
' Each overlay object must have a unique identifier.
  DECLARE FUNCTION ZD_DrawPolyLineToCtrl LIB "GDIMAGE.DLL" ALIAS "ZD_DrawPolyLineToCtrl" ( _
  BYVAL hGDImageCtrl AS LONG, _        ' The GDImage control handle.
  BYVAL pXY AS POINTS PTR, _           ' Pointer to an ARRAY of POINTS (holding x,y coordinates of each point).
  BYVAL ArraySize AS LONG, _           ' UBOUND - LBOUND + 1 = number of point in the array.
  BYVAL ColrARGB AS LONG, _            ' The ARGB color to use.
  BYVAL CurveSize AS LONG, _           ' Size of the polyline.
  BYVAL ObjID AS LONG, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  BYVAL ZS_STYLE AS LONG, _            ' The object Generic STYLE (use at least %ZS_VISIBLE to show it).
  BYVAL ZD_STYLE AS LONG, _            ' The object Drawing STYLE (see below).
  OPTIONAL BYVAL Use3D AS LONG _       ' The shadow 3D offset.
  ) AS LONG
' Return:
' TRUE (-1) if success, FALSE (0) if error
'
' GDImage Drawing STYLE                  Drawing mode:
' ---------------------                  -------------
' %ZD_DRAW_OUTLINE                       Border only (frame mode)
' %ZD_DRAW_FILLED                        Fill mode
' %ZD_DRAW_3DIN                          Fill with 3D-IN effect
' %ZD_DRAW_3DOUT                         Fill with 3D_Out effect
' %ZD_DRAW_OPEN                          Do not apply to rectangle
'****************************************************************************
'
'****************************************************************************
' Version 1.10
' Process pending window or dialog messages during animation sequence.
  DECLARE FUNCTION ZD_DoEvents LIB "GDIMAGE.DLL" ALIAS "ZD_DoEvents" () AS LONG
' Return:
' %WM_QUIT if user presses on exit button else %NULL.
'****************************************************************************
'
'****************************************************************************
' Version 1.10
' To show or hide a GDImage overlay object
  DECLARE SUB ZD_ShowObject LIB "GDIMAGE.DLL" ALIAS "ZD_ShowObject" ( _
  BYVAL ObjID AS LONG, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  BYVAL ShowOrHide AS LONG _           ' %TRUE = SHOW, %FALSE = HIDE.
  )
' Apply to any of the ZD_DrawXXXToCtrl functions.
'****************************************************************************
'
'****************************************************************************
' Version 1.10
' Check for visibility of a GDImage overlay object
  DECLARE FUNCTION ZD_IsObjectVisible LIB "GDIMAGE.DLL" ALIAS "ZD_IsObjectVisible" ( _
  BYVAL ObjID AS LONG _                ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  ) AS LONG
' Return:
' TRUE (-1) if visible, FALSE (0) if not.
'****************************************************************************
'
'****************************************************************************
' Version 1.14
' Get the STYLE of a GDImage overlay object
  DECLARE FUNCTION ZD_GetObjectStyle LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectStyle" ( _
  BYVAL ObjID AS LONG _                ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  ) AS LONG
' Return:
' The STYLE of the object.
'****************************************************************************
'
'****************************************************************************
' Version 1.14
' Set the STYLE of a GDImage overlay object
  DECLARE SUB ZD_SetObjectStyle LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectStyle" ( _
  BYVAL ObjID AS LONG, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  BYVAL UseStyle AS LONG _             ' The new style to use (must be a valid GDImage style).
  )
' See: GDImage overlay Generic STYLE
' Note: Use ZI_UpdateWindow to refresh the display after the style change.
'****************************************************************************
'
'****************************************************************************
' Version 1.10
' To set up the Alpha channel of a specific overlay object
  DECLARE SUB ZD_SetObjectAlpha LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectAlpha" ( _
  BYVAL ObjID AS LONG, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  BYVAL Alpha AS BYTE, _               ' The alpha channel (range 0-255, 0 = transparent, 255 = opaque).
  BYVAL RedrawParent AS LONG _         ' TRUE causes immediat redraw of the object parent
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.10
' To get the ARGB parameters of a specific overlay object
  DECLARE SUB ZD_GetObjectARGB LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectARGB" ( _
  BYVAL ObjID AS LONG, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  BYREF Alpha AS BYTE, _               ' The alpha channel (range 0-255, 0 = transparent, 255 = opaque).
  BYREF Red AS BYTE, _                 ' The RED component (0-255).
  BYREF Green AS BYTE, _               ' The GREEN component (0-255).
  BYREF Blue AS BYTE _                 ' The BLUE component (0-255).
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.10
' To set the ARGB parameters of a specific overlay object
  DECLARE SUB ZD_SetObjectARGB LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectARGB" ( _
  BYVAL ObjID AS LONG, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  BYVAL Alpha AS BYTE, _               ' The alpha channel (range 0-255, 0 = transparent, 255 = opaque).
  BYVAL Red AS BYTE, _                 ' The RED component (0-255).
  BYVAL Green AS BYTE, _               ' The GREEN component (0-255).
  BYVAL Blue AS BYTE _                 ' The BLUE component (0-255).
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.10
' Retrieve the immediate parent of the overlay object
  DECLARE FUNCTION ZD_GetObjectParent LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectParent" ( _
  BYVAL ObjID AS LONG _                ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  ) AS LONG
' Return:
' The GDImage control handle of the parent.
'****************************************************************************
'
'****************************************************************************
' Version 1.10
' Retrieve the bounding size that best fit the overlay object region
  DECLARE SUB ZD_GetObjectBound LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectBound" ( _
  BYVAL ObjID AS LONG, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one)
  BYREF BoundWidth AS LONG, _          ' The bounding with
  BYREF BoundHeight AS LONG _          ' The bounding height
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.10
' Retrieve overlay object X, Y coordinates
  DECLARE SUB ZD_GetObjectXY LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectXY" ( _
  BYVAL ObjID AS LONG, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one)
  BYREF x AS LONG, _                   ' The X coordinate
  BYREF y AS LONG _                    ' The Y coordinate
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.10
' Set the X,Y coordinates of an overlay object.
  DECLARE SUB ZD_SetObjectXY LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectXY" ( _
  BYVAL ObjID AS LONG, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one)
  BYVAL x AS LONG, _                   ' The X coordinate
  BYVAL y AS LONG, _                   ' The Y coordinate
  BYVAL RedrawParent AS LONG _         ' TRUE causes immediat redraw of the object parent
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.14
' To Get the Z-order of an overlay object
  DECLARE FUNCTION ZD_GetObjectZorder LIB "GDIMAGE.DLL" ALIAS "ZD_GetObjectZorder" ( _
  BYVAL ObjID AS LONG _                ' The unique object IDentifier (each object MUST USE A UNIQUE one)
  ) AS LONG
' Return:
' The overlay object Z-order
'****************************************************************************
'
'****************************************************************************
' Version 1.14
' You can use these constants
  %ZD_ORDER_TOP    = &HFFFFFF          ' Z-order Top
  %ZD_ORDER_BOTTOM = &HFFFF            ' Z-Order Bottom
' To Set the Z-order of an overlay object
  DECLARE FUNCTION ZD_SetObjectZorder LIB "GDIMAGE.DLL" ALIAS "ZD_SetObjectZorder" ( _
  BYVAL ObjID AS LONG, _               ' The unique object IDentifier (each object MUST USE A UNIQUE one)
  BYVAL SetOrder AS LONG _             ' The new Z-order of the object
  ) AS LONG
' Return:
' 0 = Error
' ELSE the PREVIOUS z-order of the object.
'****************************************************************************
'
'****************************************************************************
' Version 1.17
' Create a BITMAP overlay object.
  DECLARE FUNCTION ZD_DrawBitmapToCtrl LIB "GDIMAGE.DLL" ALIAS "ZD_DrawBitmapToCtrl" ( _
  BYVAL hGDImageCtrl AS LONG, _        ' The GDImage control handle.
  BYVAL x AS LONG, _                   ' The X coordinate.
  BYVAL y AS LONG, _                   ' The Y coordinate.
  BYVAL hBitmap AS LONG, _
  BYVAL ColrARGB AS LONG, _
  BYVAL ObjID AS LONG, _
  BYVAL ZS_STYLE AS LONG _
  ) AS LONG
' Return:
' TRUE (-1) if success, FALSE (0) if error. 
'****************************************************************************
'
'****************************************************************************
' Version 1.20
' To be used with a bitmap object.
' Retrieve a copy of the entire bitmap for the object IDentifier being used,
' using a 2 dimensions array of the form (x,y) pointing directly to pixel.
' You can use the array coordinates as you would do with a standard DC, 
' because pixel 0,0 is at coordinate Array(0,0). 
' Once your are done with the array, the bitmap is replaced using ZD_SetBitmapObjectBits.
' (see ZD_SetBitmapObjectBits)
  DECLARE FUNCTION ZD_GetBitmapObjectBits LIB "GDIMAGE.DLL" ALIAS "ZD_GetBitmapObjectBits" ( _
  BYVAL ObjID AS LONG, _                   ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  PixelArray() AS LONG _                   ' Array using 2 dimensions (Y,Y) matching the pixel coordinates.
  ) AS LONG
' Return:
' Null if error, else success.
'****************************************************************************
'
'****************************************************************************
' Version 1.20
' To be used with a bitmap object.
' Replace a copy of a bitmap that was retrieved as a device-independent bitmap.
' (see ZD_GetBitmapObjectBits)
  DECLARE FUNCTION ZD_SetBitmapObjectBits LIB "GDIMAGE.DLL" ALIAS "ZD_SetBitmapObjectBits" ( _
  BYVAL ObjID AS LONG, _                   ' The unique object IDentifier (each object MUST USE A UNIQUE one).
  PixelArray() AS LONG, _                  ' Array using 2 dimensions (Y,Y) matching the pixel coordinates.
  OPTIONAL BYVAL DoNotClearArray AS LONG _ ' Boolean flag, %TRUE = DO NOT clear the array.
  )AS LONG
' Return:
' Null if error, else success.
'****************************************************************************
'
'****************************************************************************
' Version 1.21
  TYPE ZPOLYGON
      pXY        AS DWORD    ' 32-bit unsigned POINTS PTR
      ArraySize  AS INTEGER  ' 16-bit signed SHORT integer
      ObjID      AS LONG     ' 32-bit signed LONG integer
      ColorARGB  AS LONG     ' 32-bit signed LONG integer
      PenSize    AS INTEGER  ' 16-bit signed SHORT integer
      ZS_Style   AS LONG     ' 32-bit signed LONG integer
      ZD_Style   AS LONG     ' 32-bit signed LONG integer
  END TYPE
'****************************************************************************
'
'****************************************************************************
' Version 1.21
' Draws a series of closed polygons. 
' Each polygon is outlined or filled by using a specific pen size and ARGB color. 
' The polygons drawn by this function can overlap.
  DECLARE FUNCTION ZD_PolyPolygon LIB "GDIMAGE.DLL" ALIAS "ZD_PolyPolygon" ( _
  BYVAL hGDImageCtrl AS LONG, _        ' The GDImage control handle.
  zp() AS ZPOLYGON, _                  ' The polypolygon description.
  BYVAL PolygonCount AS LONG _         ' The plygon count.
  ) AS LONG
' Return:
' TRUE (-1) if success, FALSE (0) if error
'****************************************************************************
'
'****************************************************************************
' Version 1.21
' Show or hide a list of GDImage overlay objects at once.
  DECLARE SUB ZD_ShowObjectList LIB "GDIMAGE.DLL" ALIAS "ZD_ShowObjectList" ( _
  BYVAL ObjectList AS LONG PTR, _     ' A long pointer to an array of object ID
  BYVAL ListSize AS LONG, _           ' The size of the array.
  BYVAL ShowOrHide AS LONG _          ' %TRUE = SHOW, %FALSE = HIDE.
  )
'****************************************************************************
'
'
'****************************************************************************
'****************************************************************************
'*                                                                          *
'*                             HELPER FUNCTIONS                             *
'*                                                                          *
'****************************************************************************
'****************************************************************************
'
'****************************************************************************
' Version 1.00
' Retrieve the instance of the current module
  DECLARE FUNCTION zInstance LIB "GDIMAGE.DLL" ALIAS "zInstance" () AS LONG
' Return:
' the instance handle of the running application.
'****************************************************************************
'
'****************************************************************************
' Version 1.07
' Beep the user.
  DECLARE SUB zFocusBeep LIB "GDIMAGE.DLL" ALIAS "zFocusBeep" ()
'****************************************************************************
'
'****************************************************************************
' Version 1.11
' Compute CPU SPEED, handy to compute animation speed.
  DECLARE FUNCTION zGetCPUspeed LIB "GDIMAGE.DLL" ALIAS "zGetCPUspeed" () AS LONG
'****************************************************************************
'
'****************************************************************************
' Version 1.00
' Check if file exist
  DECLARE FUNCTION zExist LIB "GDIMAGE.DLL" ALIAS "zExist" ( _
  BYVAL FullPathName AS STRING _ ' The name of the file to check.
  ) AS LONG
' Return:
' TRUE (-1) if exist, FALSE (0) if not.
'****************************************************************************
'
'****************************************************************************
' Version 1.16
' Generic I/O file manager faster and less overhead than built-in PB's functions.
' OPEN File
  DECLARE FUNCTION zFOpen LIB "GDIMAGE.DLL" ALIAS "zFOpen" ( _
  BYVAL FullPathName AS STRING, _ ' The name of the file to open.
  BYVAL AccessMode AS LONG, _
  BYVAL ShareMode AS LONG, _
  BYREF hFile AS LONG _
  ) AS LONG
'****************************************************************************
'
'****************************************************************************
' Version 1.16
' Generic I/O file manager faster and less overhead than built-in PB's functions
' CLOSE File
  DECLARE SUB zFClose LIB "GDIMAGE.DLL" ALIAS "zFClose" ( _
  BYREF hFile AS LONG _
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.16
' Generic I/O file manager faster and less overhead than built-in PB's functions
' GET buffer
  DECLARE FUNCTION zFGet LIB "GDIMAGE.DLL" ALIAS "zFGet" ( _
  BYVAL hFile AS LONG, _
  BYREF sBuffer AS STRING _
  ) AS LONG
'****************************************************************************
'
'****************************************************************************
' Version 1.16
' Generic I/O file manager faster and less overhead than built-in PB's functions
' Disk size of an open file FLOF
  DECLARE FUNCTION zFlof LIB "GDIMAGE.DLL" ALIAS "zFlof" ( _
  BYVAL hFile AS LONG _
  ) AS LONG
'****************************************************************************
'
'****************************************************************************
  MACRO Pi = 3.141592653589793##
  MACRO PiDiv4 = 0.785398163397448##
  MACRO DegreesToRadians(Deg) = Deg * 0.0174532925199432957##

'****************************************************************************
'
'****************************************************************************

' Version 1.21
' Low level function to retrieve a device-independent bitmap.
  DECLARE FUNCTION zGetDIBits LIB "GDIMAGE.DLL" ALIAS "zGetDIBits" ( _
  BYVAL hBitmap AS LONG, _                 ' A valid bitmap handle.
  PixelArray() AS LONG _                   ' Array using 2 dimensions (Y,Y) matching the pixel coordinates.
  ) AS LONG

' Version 1.21
' Low level function to replace a copy of a bitmap that was retrieved as a device-independent bitmap.
  DECLARE FUNCTION zSetDIBits LIB "GDIMAGE.DLL" ALIAS "zSetDIBits" ( _
  BYVAL hBitmap AS LONG, _                 ' A valid bitmap handle.
  PixelArray() AS LONG _                   ' Array using 2 dimensions (Y,Y) matching the pixel coordinates.
  ) AS LONG

' Version 1.30
' Low level function to split an ARGB color.
  DECLARE SUB zSplitColorARGB LIB "GDIMAGE.DLL" ALIAS "zSplitColorARGB" ( _
  BYVAL ARGB&, _                           ' The ARGB color to split
  Alpha AS BYTE, _                         ' The Alpha channel in the range 0-255.
  Red AS BYTE, _                           ' The Red component in the range 0-255.
  Green AS BYTE, _                         ' The Green component in the range 0-255.
  Blue AS BYTE _                           ' The Blue component in the range 0-255.
  )

'****************************************************************************
'
'****************************************************************************
'****************************************************************************
'***                                                                      ***
'***                         SLIDE SHOW FUNCTIONS                         ***
'***                                                                      ***
'****************************************************************************
'****************************************************************************
' Version 1.25
  TYPE ZSLIDESHOW
    ' Slide section
      FilName   AS ASCIIZ * 260
      Delay     AS LONG
      Effect    AS INTEGER
      Grain     AS INTEGER
    ' Font section
      Legend    AS ASCIIZ * 128
      FontName  AS ASCIIZ * 64
      FontSize  AS INTEGER
      FontColor AS LONG
      Shadow    AS BYTE
      Location  AS BYTE
  END TYPE

' Transition effects
  %ZE_EFFECT_MIN                 = 0  '
  %ZE_TRANSLUCENT_SPIRAL         = 0  ' Translucent spiral (uGrain to adjust speed).
  %ZE_SMOOTH_FADING              = 1  ' Smooth fading (uGrain to adjust speed).
  %ZE_MOVE_BOTTOM_TO_TOP         = 2  ' Moving from bottom to top (uGrain to adjust speed).
  %ZE_VERTICAL_LINE              = 3  ' Vertical line (use uGrain to change space between lines).
  %ZE_VERTICAL_LINE_FILLED_RIGHT = 4  ' Vertical line (use uGrain to change space between lines).
  %ZE_CHECKER_BOARD              = 5  ' Checker board (use uGrain for larger square).
  %ZE_RANDOM_DOT                 = 6  ' Random dots (use uGrain for larger dots).
  %ZE_WIPE_TO_CENTER             = 7  ' Wipe to center (uGrain to adjust speed).
  %ZE_STRETCH_FROM_CENTER        = 8  ' Stretch from center (uGrain to adjust speed).
  %ZE_PUSH_LEFT_TO_RIGHT         = 9  ' Push from left to right (uGrain to adjust speed).
  %ZE_PUSH_TOP_TO_BOTTOM         = 10 ' Push from top to bottom (uGrain to adjust speed).
  %ZE_NO_EFFECT                  = 11 ' Cut mode (no transition effect).
  %ZE_EFFECT_MAX                 = 11

' Legend location
  %ZE_TXT_TOP_LEFT               = 1  ' Text on the top, left justified.
  %ZE_TXT_TOP_CENTER             = 2  ' Text on the top, centered.
  %ZE_TXT_TOP_RIGHT              = 3  ' Text on the top, right justified.
  %ZE_TXT_MIDDLE_CENTER          = 4  ' Text on the middle, centered.
  %ZE_TXT_BOTTOM_LEFT            = 5  ' Text on the bottom, left justified. 
  %ZE_TXT_BOTTOM_CENTER          = 0  ' Text on the bottom, centered.
  %ZE_TXT_BOTTOM_RIGHT           = 6  ' Text on the bottom, right justified.

'****************************************************************************
'
'****************************************************************************
' Version 1.25
' Start playing a GDImage slide show.
  DECLARE SUB ZI_SlideAnimate LIB "GDIMAGE.DLL" ALIAS "ZI_SlideAnimate" ( _
  BYVAL hGDImageCtrl AS LONG, _ ' The GDImage control handle.
  ImageList() AS ZSLIDESHOW, _  ' The Slide show array, holding the list of image to play.
  BYVAL LoopMode AS LONG _      ' Boolean flag, TRUE = play slide show in loop mode.
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.25
' STOP a playing GDImage slide show.
  DECLARE SUB ZI_SlideStop LIB "GDIMAGE.DLL" ALIAS "ZI_SlideStop" ()
'****************************************************************************
'
'****************************************************************************
' Version 1.25
' Play a GDImage slide show in incremental order.
  DECLARE SUB ZI_SlidePlayIncrOrder LIB "GDIMAGE.DLL" ALIAS "ZI_SlidePlayIncrOrder" ()
'****************************************************************************
'
'****************************************************************************
' Version 1.25
' Play a GDImage slide show in decremental order.
  DECLARE SUB ZI_SlidePlayDecrOrder LIB "GDIMAGE.DLL" ALIAS "ZI_SlidePlayDecrOrder" ()
'****************************************************************************
'
'****************************************************************************
' Version 1.25
' PLAY a GDImage slide show that has been previously PAUSED.
  DECLARE SUB ZI_SlidePlay LIB "GDIMAGE.DLL" ALIAS "ZI_SlidePlay" ()
'****************************************************************************
'
'****************************************************************************
' Version 1.25
' PAUSE a playing GDImage slide show.
  DECLARE SUB ZI_SlidePause LIB "GDIMAGE.DLL" ALIAS "ZI_SlidePause" ()
'****************************************************************************
'
'****************************************************************************
'****************************************************************************
'*                                                                          *
'*                             OpenGL FUNCTIONS                             *
'*                                                                          *
'****************************************************************************
'****************************************************************************
'
'****************************************************************************
  %ZI_GLDC      = 8  ' OpenGL Device Context
  %ZI_GLRC      = 9  ' OpenGL Rendering Context
'****************************************************************************
'
'****************************************************************************
' Version 1.30
' No need to use it if you have already registered the RegisterGDImageClass
' -------------------------------------------------------------------------
' Must be done in the WinMain section BEFORE USING any of the GDImage function.
' Parameter: None
  DECLARE FUNCTION RegisterGLImageClass LIB "GDIMAGE.DLL" ALIAS "RegisterGLImageClass" () AS LONG
' Return:
' 0 = means failure, any other value means registered.
'****************************************************************************
'
'****************************************************************************
' Version 1.30
' Create an OpenGL texture from any of the supported GDImage graphic format.
' GDImage takes care of all the hard stuff to create a correct OpenGL texture.
  DECLARE FUNCTION ZI_CreateGLTextureFromFile LIB "GDIMAGE.DLL" ALIAS "ZI_CreateGLTextureFromFile" ( _
  zFullPathName AS ASCIIZ, _  ' Name of the graphic file to create the texture from.
  xPower2 AS LONG, _          ' A value in the range: 2, 4, 16, 32, 64, 128, 256, 512, etc. 
  yPower2 AS LONG, _          ' A value in the range: 2, 4, 16, 32, 64, 128, 256, 512, etc.
  PixelArray() AS BYTE _      ' Byte array holding the texture.
  ) AS LONG
' Return:
' If the function succeeds the returned value is %TRUE, 
' and the PixelArray is full of bytes that are already converted to the internal RGBA OpenGL format.
'****************************************************************************
'
'****************************************************************************
' Version 1.30
' Simplified API to create on the fly an OpenGL texture from a supported GDImage graphic file.
  DECLARE FUNCTION ZI_SetGLTextureFromFile LIB "GDIMAGE.DLL" ALIAS "ZI_SetGLTextureFromFile" ( _
  zFullPathName AS ASCIIZ _   ' Name of the graphic file to create the texture from.
  ) AS LONG
' Return:
' An OpenGL error code in case of Error. 
'****************************************************************************
'
'****************************************************************************
' Version 1.30
' Enable the use of OpenGL with a previously "bounded" GDImage OpenGL texture.
  DECLARE SUB ZI_InitGLControl LIB "GDIMAGE.DLL" ALIAS "ZI_InitGLControl" ( _
  BYVAL ARGB AS LONG _ ' The GDImage ARGB color to paint the control background.
  )
'****************************************************************************
'
'****************************************************************************
' Version 1.30
' Allows you to resize the "view port" of a GDImage OpenGL control during WM_SIZE message.
' The GDImage control being the container of the OpenGL "view port", 
' you must resize both the control and the "veiw port".
  DECLARE SUB ZI_ResizeGLWindow LIB "GDIMAGE.DLL" ALIAS "ZI_ResizeGLWindow" ( _
  BYVAL hGDImageCtrl AS LONG _ ' The GDimage control handle.
  )
' Note: To resize automatically a GDImage control use the ZI_SetAnchorMode API.
'****************************************************************************
'
'****************************************************************************
' Version 1.30
' Allows you to update a GDImage OpenGL control.
  DECLARE SUB ZI_UpdateGLWindow LIB "GDIMAGE.DLL" ALIAS "ZI_UpdateGLWindow" (BYVAL hWnd AS LONG)
' Note:
' This API must be called from your "DrawScene" procedure to display the rendered animation.
'****************************************************************************
'
'****************************************************************************
' Version 1.30
' To retrieve the GDImage OpenGL permanent (CS_OWNDC) Device Context.
  DECLARE FUNCTION ZI_GetGLDC LIB "GDIMAGE.DLL" ALIAS "ZI_GetGLDC" ( _
  BYVAL hGDImageCtrl AS LONG _ ' The GDimage control handle.
  ) AS LONG
' Do not delete this DC.
'****************************************************************************
'
'****************************************************************************
' Version 1.30
' To retrieve the GDImage OpenGL Rendering Context. 
  DECLARE FUNCTION ZI_GetGLRC LIB "GDIMAGE.DLL" ALIAS "ZI_GetGLRC" ( _
  BYVAL hGDImageCtrl AS LONG _ ' The GDimage control handle.
  ) AS LONG

  